<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsProduct_property extends JPlugin
{	
	var $keys = array('property', 'price_affect', 'color', 'checked');
	var $SEPARATOR = '__PROD_PROP__';
	
	function plgJoomsuite_content_fieldsProduct_property(&$subject, $params) {
		parent::__construct($subject, $params);
	}
	
	function onRenderField(&$obj, &$params, $type) {
		if($type != 'product_property') 
			return;
		JHTML::_('behavior.tooltip');
		$property_type = $params->get('property_type', 0);
		if ($property_type == 1)
		{
			JHTML::_('behavior.calendar');
			$doc = JFactory::getDocument();
			$js = '
			function showCalendar(id, format, showsTime, showsOtherMonths) 
			{
				  var el = document.getElementById(id);
				  if (_dynarch_popupCalendar != null) {
				    // we already have some calendar created
				    _dynarch_popupCalendar.hide();                 // so we hide it first.
				  } else {
				    // first-time call, create the calendar.
				    var cal = new Calendar(1, null, selected, closeHandler);
				    // uncomment the following line to hide the week numbers
				    // cal.weekNumbers = false;
				    if (typeof showsTime == "string") {
				      cal.showsTime = true;
				      cal.time24 = (showsTime == "24");
				    }
				    if (showsOtherMonths) {
				      cal.showsOtherMonths = true;
				    }
				    _dynarch_popupCalendar = cal;                  // remember it in the global var
				    cal.setRange(1900, 2070);        // min/max year allowed.
				    cal.create();
				  }
				  _dynarch_popupCalendar.setDateFormat(format);    // set the specified date format
				  _dynarch_popupCalendar.parseDate(el.value);      // try to parse the text in field
				  _dynarch_popupCalendar.sel = el;                 // inform it what input field we use
				
				  // the reference element that we pass to showAtElement is the button that
				  // triggers the calendar.  In this example we align the calendar bottom-right
				  // to the button.
				  _dynarch_popupCalendar.showAtElement(el.nextSibling, "Br");        // show the calendar
				
				  return false;
				}
				
				var MINUTE = 60 * 1000;
				var HOUR = 60 * MINUTE;
				var DAY = 24 * HOUR;
				var WEEK = 7 * DAY;
				
				// If this handler returns true then the "date" given as
				// parameter will be disabled.  In this example we enable
				// only days within a range of 10 days from the current
				// date.
				// You can use the functions date.getFullYear() -- returns the year
				// as 4 digit number, date.getMonth() -- returns the month as 0..11,
				// and date.getDate() -- returns the date of the month as 1..31, to
				// make heavy calculations here.  However, beware that this function
				// should be very fast, as it is called for each day in a month when
				// the calendar is (re)constructed.
				function isDisabled(date) {
				  var today = new Date();
				  return (Math.abs(date.getTime() - today.getTime()) / DAY) > 10;
			}';
			$doc->addScriptDeclaration($js);
		}
		
		// User defined properties
		$userProperties = @unserialize($obj->field_value);		
		$paramData = $this->_getDataFromParams($params);
		
		// Get the data to display.
		$data = null;
		
		if (is_array($userProperties)) {
			$data = $userProperties;
			
			foreach ($paramData as $k => $v) {
				if (isset($data[ $k ])) {	
					if (isset($paramData[ $k ]['checked']) && !!$paramData[ $k ]['checked'])									
						$data[ $k ]['checked'] = 1;
				}
				else
					$data[ $k ] = $v;
			}
		}
		else if (is_array($paramData) && count($paramData))
			$data = $paramData;

		// Sort the data
		$this->_sortData($data, $params);
		$uid = uniqid('plg_product_categories_');
		?>
		<table>
			<thead>
				<tr>
					<th><?php echo JText::_('Show'); ?></th>
					<th><?php echo JText::_('Property') ?></th>
					<th><?php echo JText::_('Price affect'); ?></th>
				<?php if (count($data) > 1) : ?>
					<th>&nbsp;</th>
					<th><?php echo JText::_('Show'); ?></th>
					<th><?php echo JText::_('Property') ?></th>
					<th><?php echo JText::_('Price affect'); ?></th>
				<?php endif; ?>
				</tr>
			</thead>
			<tbody>
		<?php
			$putTr = 1;
			$count = 0;
			if (is_array($data)) {
				foreach ($data as $prop) {
					$checked = isset($prop['checked']) && $prop['checked'] ? 'checked' : '';
					$property = htmlspecialchars($prop['property'], ENT_QUOTES, 'UTF-8');
					$colorStartString = '';
					$colorEndString = '';
					if (!empty($prop['color'])){
						$colorStartString = '<span style="color:'.$prop['color'].'">';
						$colorEndString = '</span>';
					}
					
					if ($putTr)
						echo '<tr>';
	?>
					<td align="center"><input class="inputbox" type="checkbox" name="fields[<?php echo $obj->id; ?>][property][<?php echo $count; ?>]" value="<?php echo $property; ?>" <?php echo $checked; ?> /></td>
					<td><?php echo $colorStartString, $property, $colorEndString; ?></td>
					<td>
						<input class="inputbox" type="text" style="width:50px" onkeyup="validateAffect<?php echo $uid; ?>(this);" name="fields[<?php echo $obj->id; ?>][price_affect][<?php echo $count; ?>]" value="<?php echo htmlspecialchars($prop['price_affect'], ENT_QUOTES, 'UTF-8'); ?>" />
					</td>
					<td>&nbsp;&nbsp;&nbsp;</td>
	<?php
						
					if (!$putTr)
						echo '</tr>';
					$putTr = 1 - $putTr;
						
					$count++;
				}
			}
				
			if (is_array($data) && $putTr) {
				// Close the open tr.
				echo '<td colspan="3">&nbsp;</td></tr>';
			}
		?>
			</tbody>
		</table>
		<script>
			var lastCount<?php echo $uid; ?> = <?php echo $count; ?>;
			
			function validateAffect<?php echo $uid; ?>( o ) {
				if (typeof o.value == 'undefined') {
					o = this;
					console.log('o.value is undefined');
				}
				// Trim the string
				o.value = o.value.replace(/^\s*/, "").replace(/\s*$/, "");
				
				if (!o.value.match(/^[-+][0-9]*[.,]{0,1}?[0-9]+$/)) {
					if (o.style.backgroundColor != 'red')
						o.originalBackgroundColor_ = o.style.backgroundColor;
					o.style.backgroundColor = 'red';
				}
				else
					o.style.backgroundColor = o.originalBackgroundColor_;
			}
			<?php if ($params->get('allow_adding', 1)) : ?>
			function addNew<?php echo $uid; ?>() {
				var cont = document.getElementById('<?php echo 'add'.$uid; ?>');
				
				var myDiv = document.createElement('DIV');
				var outerId = 'option' + lastCount<?php echo $uid; ?>;
				
				myDiv.id = outerId;
				
				var property = document.createElement('INPUT');
				property.type = 'text';
				property.id = 'fields<?php echo $obj->id; ?>' + lastCount<?php echo $uid; ?>;
				property.name = 'fields[<?php echo $obj->id; ?>][property][' + lastCount<?php echo $uid; ?> + ']';
				property.style.width = '250px';
				<?php if ($property_type == 1):?>
				var btCal = document.createElement('IMG');
				btCal.id = 'fields<?php echo $obj->id; ?>' + lastCount<?php echo $uid; ?> + '_img';
				btCal.className = 'calendar';
				btCal.src = '<?php echo JURI::root(true); ?>/templates/system/images/calendar.png';
				btCal.alt = 'calendar';
				btCal.onclick = function(lastCount<?php echo $uid; ?>)
				{
					elid = this.id.slice(0, -4);
					return showCalendar(elid, '%d-%m-%Y');
				}
				<?php endif; ?>
				
				var affect = document.createElement('INPUT');
				affect.type = 'text';
				affect.name = 'fields[<?php echo $obj->id; ?>][price_affect][' + lastCount<?php echo $uid; ?> + ']';
				affect.style.width = '150px';
				affect.onkeyup = validateAffect<?php echo $uid; ?>;
				affect.value = '+0';
				
				var btDelete = document.createElement('A');
				btDelete.href = 'javascript:void(0);';
				btDelete.innerHTML = '<?php echo JText::_('Remove'); ?>';
				btDelete.style.float = 'right';
				btDelete.onclick = function() {
					var theDiv = document.getElementById(outerId);
					if (theDiv)
						cont.removeChild(theDiv);
				}
				
				myDiv.appendChild(property);
				<?php if ($property_type == 1):?>
				myDiv.appendChild(btCal);
				<?php endif;?>
				myDiv.appendChild(affect);
				myDiv.appendChild(btDelete);
				
				cont.appendChild(myDiv);
				
				lastCount<?php echo $uid; ?>++;
			}
			<?php endif; ?>
		</script>
		<?php if ($params->get('allow_adding', 1)) : ?>
		<a title="<?php echo JText::_('Add new property'); ?>" href="javascript:void(0);" onclick="addNew<?php echo $uid; ?>();"/><?php echo JText::_('Add new'); ?></a>
		<div id="add<?php echo $uid; ?>"></div>
		<?php endif; ?>
		<?php
	}
	
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'product_property') 
			return;
		
		$db = & JFactory::getDBO();
		$property_type = $params->get('property_type', 0);
		
		// We need only these keys
		$keys = array('property', 'price_affect');
		// Normalize the data, so it's easy to form a query:
		$toSave = array();
		foreach ($value['property'] as $k => $prop) {
			$tmp = array();
			
			$tmp['checked'] = 1;
			
			foreach ($keys as $arrayKey) {
				if (isset($value[$arrayKey][ $k ]))
				{
					$prepval = $value[$arrayKey][ $k ];
					$tmp[$arrayKey] = $prepval;
				}
				else 
				{
					$tmp[$arrayKey] = 0;
				}
			}
			$toSave[$prop] = $tmp;
		}
		
/* Uncomment this lines to put the data to #__js_res_field_extra */
// NOTE: The field values will be stored in js_res_extra:
// 
// ref_id => property name
// field_id => field_id
// field_value_id => field_value_id
// record_id => record_id
// ip => color.
// value => price affect
// user_id => is selected by default?

//		// Delete the previous stuff.
//		$q = 'DELETE FROM #__js_res_field_extra WHERE field_id = '.$id.' AND record_id = '.$row->id.' AND user_id IN (0, 1) AND field_value_id = 0';
//		$db->setQuery( $q );
//		$db->query();
		
//		// Now, insert it all to database.
//		$q = 'INSERT INTO #__js_res_field_extra (`user_id`, `ref_id`, '.
//			'`ctime`, `ip`, `value`, `field_id`, `field_value_id`, `record_id`) ';
//		
//		$vals = array();
//		$quotedType = $db->Quote($type);
//		foreach ($toSave as $property => $s) {
//			$property = JString::trim($property);
//			$priceAffect = JString::trim($s['price_affect']);
//			
//			if (!preg_match('/^[-+][0-9]*[.,]{0,1}?[0-9]+$/', $priceAffect)) {
//				JError::raiseWarning(0, JText::_('Wrong price affect format'));
//				$error = true;
//			}
//			
//			if (!strlen($property) || !strlen($priceAffect))
//				continue;
//		
//			if ($s['checked'] > 1)
//				$s['checked'] = 1;
//			else
//				$s['checked'] = 0;
//				
//			$vals[] = '('.(int)$s['checked'].', '.$db->Quote($property).', NOW(), '.
//				$db->Quote($s['color']).', '.$db->Quote($priceAffect). ', '.$id.', '.
//				'0 /*Field value id*/, '.$row->id.')';
//		}
//		
//		$q .= ' VALUES '.implode("\n,", $vals);
//		
//		$db->setQuery( $q );	
//		$db->query();
		$value = serialize($toSave);
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	
		if($type != 'product_property') return;
		if(!isset($field->field_value)) return;
		
		$default = isset($field->default_values) ? $field->default_values : null;
		
		//print_r($default);echo "<br>";
		/*if (isset($default[$field->fid]))
			$default = $default[$field->fid];
		else
			$default = null;
*/
		$data = @unserialize($field->field_value);
		if(!count($data)) return;
		
		$this->_sortData($data, $params);
		
		if (!is_array($data) || !count($data)) 
			return;
			
		$paramData = $this->_getDataFromParams($params);
		$isSelect = false;
		$isRadio = false;
		$multiple = '';
		switch ($params->get('property_format', 'select')) {
			case "select":
				$isSelect = true;
				break;
			case "mselect":
				$isSelect = true;
				$multiple = ' multiple ';
				break;
			case "radio":
				$isRadio = true;
				break;
			case "checkbox":
				$isRadio = false;
				break;
		}
		
		
		ob_start();
		// The require_before_order param value here.. for future use ;)
		echo '<input type="hidden" name="fields[', $field->fid, '][require_before_order]" value="', $params->get('require_before_order', 0), '" />';
		
		
		// Show the selects:
		if ($isSelect) {
			$selectSize = min(count($data), $params->get('multiselect_size', 0));
			if ($selectSize)
				$selectSize = ' size="'.$selectSize.'" ';
		?>
			<select name="fields[<?php echo $field->fid ?>][property][]" class="inputbox" <?php echo $multiple, $selectSize; ?> >
			<?php
				foreach ($data as $d) {
					// Property glued with separator with price affect.
					$propValue = htmlspecialchars($d['property']. $this->SEPARATOR. $d['price_affect'], ENT_QUOTES, 'UTF-8');
					$prop = htmlspecialchars($d['property'], ENT_QUOTES, 'UTF-8');
					$color = (empty($d['color']) ? '' : ' style="color:'.$d['color'].'" ');
					
					$checked = false;
					if (isset($default['property']) && is_array($default['property'])) {
						foreach ($default['property'] as $p) {
							if ($p == $propValue) {							
								$checked = true;
								break;
							}
						}
					}
					if(!is_array($default['property']) && $default['property'] == $propValue)
						$checked = true;
					
					$checked = $checked ? ' selected="1" ' : '';
					echo '<option ', $color, $checked, 'value="', $propValue, '">', $prop, ' (', htmlspecialchars($d['price_affect'], ENT_QUOTES, 'UTF-8'), ')</option>';
				}
			?>
			</select>
		<?php
		}
		else {
			$inputType = $isRadio ? 'radio' : 'checkbox';
			$columnsNeeded = max((int)$params->get('numcols', 1), 1);
			$curCol = 0;
			
			echo '<table>';
			foreach ($data as $d) {
				$property = htmlspecialchars($d['property'], ENT_QUOTES, 'UTF-8');
				$propValue = htmlspecialchars($d['property']. $this->SEPARATOR. $d['price_affect'], ENT_QUOTES, 'UTF-8');
				$color = isset($paramData[$d['property']]['color']) ? $paramData[$d['property']]['color'] : null;
				
				$checked = false;
				if (isset($default['property']) && is_array($default['property'])) {
					foreach ($default['property'] as $p) {
						if ($p == $propValue) {
							$checked = true;
							break;
						}
					}
				}
				if(!is_array($default['property']) && $default['property'] == $propValue)
						$checked = true;
					
				$checked = $checked ? ' checked="1" ' : '';
				
				if ($curCol % $columnsNeeded == 0)
					echo '<tr>';
				echo '<td><label><input name="fields[', $field->fid, '][property]', 
					$isRadio ? '' : '['.$curCol.']', 
					'" value="', $propValue, '" type="', $inputType, '" ', $checked,' />', 
					(empty($color) ? '' : '<span style="color:'.$color.'">'),
					$property, ' (', $d['price_affect'], ')',
					(empty($color) ? '' : '</span>'),
					'</label></td>', "\n";
					
				// The last column:
				if ($curCol % $columnsNeeded == $columnsNeeded - 1)
					echo "</tr>\n";
				$curCol++;
			}
			
			if ($curCol % $columnsNeeded != $columnsNeeded - 1) {
				$colspan = $columnsNeeded - $curCol % $columnsNeeded;
				echo '<td colspan="', $colspan, '">&nbsp;</td></tr>';
			}
			echo '</table>';
		}
		
		$out = ob_get_contents();
		ob_end_clean();
	}
	
	function onRenderPropertyValue($type, &$value)
	{
		if($type != 'product_property') return;
	}
	
	/**
	 * Parses params value to needed format. The returned strings are not htmlspecialcharred %))
	 *
	 * @param JParameter $params
	 * @return array
	 */
	function _getDataFromParams(&$params) {
		$properties = explode("\n", trim($params->get('properties'), " \n"));
		
		if (!is_array($properties)) {
			$properties = array($properties);
		}
		
		// Prepare the data:
		
		// Properties from params:
		$data = array();
		foreach ($properties as $p) {
			$p = explode('::', trim($p));
			if (count($p) != 4)
				continue;
			
			$temp = array();
			$prop = '';
			foreach ($this->keys as $k) {
				if ($k == 'property') 
					$prop = reset($p);
					
				if (count( $p ))
					$temp[ $k ] = array_shift( $p );
				else
					$temp[ $k ] = false;
			}
			
			$data[$prop] = $temp;
		}
		
		return $data;
	}
	
	/**
	 * Sorts the data to be displayed.
	 *
	 * @param array $data
	 * @param JParameter $params
	 */
	function _sortData(&$data, &$params) {
		if (!is_array($data))
			return;
		switch ($params->get('ordering')) {
			case "prod":
				uksort($data, array($this, '_compareNamesCI'));
				break;
		   	case "prod_desc":
		   		uksort($data, array($this, '_compareNamesCIRev'));
		   		break;
		   	case "price":
		   		usort($data, array($this, '_comparePricesRev'));
		   		break;
		   	case "price_desc":
		   		usort($data, array($this, '_comparePrices'));
		   		break;
		}
	}
	
	function _comparePricesRev($a, $b) {
		$f = intval($a['price_affect']);
		$s = intval($b['price_affect']);
		
		return $f - $s;
	}
	
	function _comparePrices($a, $b) {
		$f = intval($a['price_affect']);
		$s = intval($b['price_affect']);
		
		return $s - $f;
	}
	
	function _compareNamesCI($a, $b) {
		return JString::strcasecmp($a, $b);
	}
	
	function _compareNamesCIRev($a, $b) {
		$v = JString::strcasecmp($a, $b);
		if ($v > 0)
			return -1;
		else if ($v < 0)
			return 1;
		return 0;
	}
}
?>